#ifndef GLSOUND_H
#define GLSOUND_H

/*
  Copyright (C) 2001-2002 Leonardo Boselli

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  Please send remarks, questions and bug reports to
    boselli@uno.it
  or write to:
    Leonardo Boselli
    Via Paoletti, 33
    18100 Imperia
    ITALY
*/

#include "fmsound.h"

#include "datasets.h"
#include "globject.h"

//
// GLSoundSource
//
class GLSoundSource: public DSSortableObject {
private:
  FM3DSound* sound;
  GLObject* object;
  M3Vector lastRenderingPosition;
public:
  GLSoundSource(FM3DSample* s, GLObject* o);
  ~GLSoundSource();
  FM3DSound* get3DSound() {return sound;}
  void set3DSound(FM3DSound* s) {sound->stop(); delete sound; sound = s;}
  void setVelocityToZero() {lastRenderingPosition.set(
    object->getPositionX(),object->getPositionY(),-object->getPositionZ()
  );}
  float getSortIndex()
    {return object->getDistance()*sound->getInvMinDistance();}
  void render(GLCamera& camera);
};

#endif // GLSOUND_H
